<style src="./Style.scss" lang="scss" scoped></style>
<script src="./Script.js"></script>

<template>
  <li class="m-dropdown m-dropdown--align-right m-nav__item" m-dropdown-toggle="click">
    <a href="javascript:void(0)" class="m-dropdown__toggle" @click="fetch()">
      <i class="icon icon-audit"></i>
    </a>
    <div class="m-dropdown__wrapper">
      <div
        class="m-dropdown__inner h-100"
        style="background: #FFFFFF; box-shadow: 0px 0px 10px rgba(68, 79, 120, 0.1); border-radius: 4px;"
      >
        <div class="m-dropdown__header d-flex align-items-center justify-content-between">
          Công việc của tôi
          <i
            class="icon icon-cancel"
            style="font-size: 14px; cursor: pointer"
            @click="onClose"
          ></i>
        </div>
        <div class="d-flex flex-column" style="height: calc(100% - 50px)">
          <div class="filter-area d-flex align-items-center">
            Lọc công việc:
            <select class="filter-select" v-model="selectedDate" @change="onFilter()">
              <option
                v-for="(value, index) in utils.objectValues(filterOptions)"
                :key="index"
                :value="value"
              >{{ value }}</option>
            </select>
          </div>
          <div class="toggle-done">
            <span v-if="showDone" @click="toggleDoneTask(false)">Ẩn việc đã hoàn thành</span>
            <span
              v-else
              @click="toggleDoneTask(true)"
            >Hiển thị việc đã hoàn thành ({{ numberOfDoneTask }})</span>
          </div>
          <div
            id="todoList"
            class="todo-list nt-scroll-primary position-relative"
            :class="{ 'overflow-hidden': isLoading }"
          >
            <Loading :is_loader="isLoading" />
            <NoResult
              v-if="!isLoading && !todoList.length"
              class="centering w-100"
              icon="icon icon-audit"
              message="Hiện tại bạn chưa có công việc nào!"
            />
            <div
              v-for="(item, index) in todoList"
              :key="index"
              class="todo-item align-items-baseline position-relative"
              :class="item.class || 'd-flex'"
            >
              <Loading :is_loader="item.isLoading" />
              <label class="nt-checkbox nt-checkbox-primary mb-0">
                <input
                  type="checkbox"
                  :checked="item.category_id === doneCategory.id"
                  @click="onChangeStatus($event.target.checked, item)"
                />
                <span class="nt-checkbox-symbol" style="top: -12px"></span>
              </label>
              <div>
                <div
                  :class="{ 'text-line-throught': item.category_id === doneCategory.id }"
                >{{ item.title }}</div>
                <div
                  v-if="!isShowExpire(item.deadline)"
                  class="d-flex align-items-center"
                  style="margin-top: 7px"
                >
                  <div class="item-expire">
                    <i class="far fa-clock"></i>
                  </div>
                  {{ getDate(item.deadline) }} - {{ getTime(item.deadline) }}
                </div>
              </div>
            </div>
            <div class="position-relative" style="margin: 10px 20px" v-if="isShowAdd">
              <Loading :is_loader="isLoadingAdd" />
              <div class="position-relative">
                <input
                  id="todoInput"
                  type="text"
                  class="input-task w-100"
                  :class="{ 'error': error }"
                  placeholder="Nhập tên công việc"
                  v-model="todoInput"
                  @keyup="addTask($event)"
                  @focusout="onFocusout()"
                />
                <i
                  class="icon icon-cancel input-task_cancel"
                  @click.stop.prevent="todoInput = ''; isShowAdd = false"
                ></i>
              </div>
              <div v-if="error" class="input-error">{{ error }}</div>
            </div>
          </div>
          <div class="show-all d-flex align-items-center">
            <button
              type="button"
              class="footer-item"
              :disabled="isShowAdd || isLoading"
              @click="onAddTask"
            >
              <i class="icon icon-plus"></i>
              Thêm công việc
            </button>
            <router-link
              class="footer-item"
              :to="{ name : 'MyJobList', params: { team_id : currentTeamId }}"
              @click.native="onClose"
            >
              <i class="icon icon-pipeline"></i>
              Xem dạng Kanban
            </router-link>
          </div>
        </div>
      </div>
    </div>
    <div class="nt-dropdown-backdrop-todo" @click.prevent="onClose"></div>
  </li>
</template>
